classdef lagrange11D < finiteElements1D
    properties(Constant,Hidden)
        % stiff element
        S = reshape([1 -1;...
                    -1 1],4,1);
        % mass element
        M = reshape(1/6*[2 1;...
                         1 2],4,1);
        % convection
        C = reshape([-1/2 1/2;...
                     -1/2 1/2],4,1);
        % RHS element
        F = 0.5*[1 1]';    
        % index of neighbours
        % trivial but for generality.
        idx = 1:2;
        assembleStep = 1;
    end
    
    methods(Static,Access=public,Hidden)  
        function [idxvec0,idxvec1,idxvec2] = makeIndex(idx,np)
            idxvec0 = reshape(idx,1,np*2);
            idxvec1 = reshape([idx;idx],1,np*4);
            idxvec2 =  reshape([idx(1,:);idx(1,:);...
                                idx(2,:);idx(2,:)]...
                                                  ,1,4*np);     
        end
        
        function [J] = makeJ(gridObj) 
            scl = superclasses(gridObj);
            for k = 1:length(scl)
                isgrid = strcmp(scl{k},'gridd');
                if isgrid
                    break;
                end
            end
            if ~isgrid
                throw(obj.wrongClass);
            end
            J = gridObj.p(2:end)-gridObj.p(1:end-1);
            
        end
    end
end