% command templates for Schnakenberg on a small domain; run cell-by-cell;
clear all; p=[]; spx=1; spy=1; nx=30; % 1 spot in x and 1 spot in y direction 
par=[sqrt(60)*sqrt(3-sqrt(8))+0.1, 0, 60]; p=ooschnakinit(p,[spx,spy],nx,par); 
p.sw.para=2; p.nc.dsmax=0.1; p.sol.ds=-0.1; p.nc.resfac=1e-3; p.nc.neig=30; 
p.nc.nsteps=50; p=setfn(p,'hom'); p.sw.bifcheck=2; p=cont(p,30);
%% hot hex 
p=mswibra('hom','bpt1','oh+',0.01); p=taugen(p,[1 -1]);
p=pmcont(p,1); p.pm.resfac=1e-4;  p.nc.dsmax=0.1;  
p=pmcont(p,10); %p=meshadac(p,'ngen',1); 
p.sol.ds=0.1; p.nc.dsmin=0.1; p.sw.bifcheck=1; p=pmcont(p,30); 
%% cold hex 
p=loadp('oh+','pt1','oh-'); p.sol.ds=-0.05; p=resetc(p); p.sw.foldcheck=1; p=pmcont(p,30); 
%% s+ 
p=mswibra('hom','bpt1','os+',0.01); 
p=taugen(p,[0 1]); p.nc.dsmax=0.1; p=pmcont(p,50);
%% s-
p=mswibra('hom','bpt1','os-',-0.01); 
p=taugen(p,[0 1]); p.nc.dsmax=0.1; p=pmcont(p,50);
%% hot beans
p=swibra('os+','bpt2','ob+',-0.05); p.nc.dsmin=0.05; p.pm.resfac=1e-3; p=pmcont(p,20);
%% cold beans
p=swibra('os-','bpt1','ob-',0.05); p.nc.dsmin=0.05; p.pm.resfac=1e-3; p=pmcont(p,10);
%% HOPF 
aux=[]; %aux.dlam=0; 
aux.tl=20; p=hoswibra('oh-','hpt1',0.05,4,'ho1',aux); 
p.sw.verb=2; p.nc.tol=1e-6; p.hopf.flcheck=0; p.file.smod=5; 
p.vol= 220.1035; 
AMG=0; p.sw.verb=3;  % set AMG=1 if ilupack available
if ~AMG; p=setbel(p,1,1e-3,10,@lss); % use BEL without ilupack 
else p=setilup(p,1e-3,100); p.fuha.lss=@lss; p.fuha.blss=@lssAMG; 
     % no bel on this one, cause ilupack seems indifferent to borders! 
end 
p.nc.dsmax=300; p.branch=[]; p.fuha.outfu=@hobra; p=cont(p,50); 
%% bifurcation diagram
figure(5); clf; lms=1; pcmp=1; 
plotbraf('hom','pt30',5,4,'lms',lms,'lw',3, 'cl','k');
plotbra('os+','pt40',5,4,'lms',lms,'lw',3,'cl','b','lab',35); 
plotbra('os-','pt50',5,5,'lms',lms,'lw',3,'cl','b','lab',40); 
plotbra('ob+','pt20',5,4,'lms',lms,'lw',3,'cl','r','lab',5,'lp',18); 
plotbra('ob-','pt10',5,5,'lms',lms,'lw',3,'cl','r','lab',5,'lp',8); 
plotbra('oh+','pt30',5,4,'lms',lms,'lw',3, 'cl','m','lab',30); 
plotbra('oh-','pt30',5,5,'lms',lms,'lw',3, 'cl','m','lab',20); 
plotbra('ho1','pt15',5,6,'lms',lms,'lw',3, 'cl','g','lab',10); 
text(1.5,6,'h','Fontsize',16,'color','m');
text(2,3.5,'s','Fontsize',16,'color','b');
text(2.5,5.0,'b','Fontsize',16,'color','r');
text(3.2,3.1,'hom','Fontsize',16,'color','k');
%axis([2.4 3.3 1 6.5]); 
%% plot of some solutions
plotsol('oh+','pt10',1,1,2); pause; plotsol('oh-','pt20',1,1,2); pause; 
plotsol('ob+','pt5',1,1,2); pause; plotsol('ob-','pt5',1,1,2); pause
plotsol('os+','pt35',1,1,2); pause; plotsol('os-','pt30',1,1,2); 
%%
p=loadp('ho1','pt15'); homovplot(p,1,1,2); 
%% fold-cont
p=spcontini('oh-','fpt1',2,'h-f');   % init fold cont in par(3)=sig 
p.plot.bpcmp=p.nc.ilam(2); figure(2); clf; % use this new param. for plotting
p.sol.ds=-0.1; p.sw.spjac=1; p.fuha.spjac=@spjac; 
%[Ja, Jn]=spjaccheck(p); pause % check impl. of spjac (comment out when fine) 
tic; p=cont(p,20); toc
clf(3); plotbraf('h-f','pt10',3,1); % plot BD for fold-cont
%% switch back to regular continuation from one of the fold points
p=spcontexit('h-f','pt20','h-a'); p.nc.dsmax=0.1; p.sw.bifcheck=0; 
p.plot.bpcmp=5;p.sol.ds=1e-3; clf(2); p.sw.spcalc=1; 
p=cont(p,1); p=pmcont(p,50); % continue in one direction, 1 initial step for saving
%% continue in other direction 
p=loadp('h-a','pt1','h-b'); p.nc.dsmax=0.05; p.sol.ds=-p.sol.ds; p=pmcont(p,30); 
%% plot new branches (and some old) 
figure(5); clf; lms=1; pcmp=1; 
plotbraf('hom','pt30',5,4,'lms',lms,'lw',3, 'cl','k');
plotbra('oh-','pt30',5,5,'lms',lms,'lw',3, 'cl','m','lab',20); 
plotbra('h-a','pt40',5,5,'lms',lms,'lw',3, 'cl','r','lab',30); 
plotbra('h-b','pt30',5,5,'lms',lms,'lw',3, 'cl','r','lab',20); 
