%%
% PLOTEVEC: plot real part of selected eigenvector from spcalc computation.
%  Returns first 4 eigenvalues in real part ordering.
%
%  muv=plotEvec(p,nr,cnr,ptype)         - use p-struct and plot for nr-largest eval
%  muv=plotEvec(dir,fname,nr,cnr,ptype) - load from file dir/fname and nr-largest   eval
% cnr=component nr to be plotted, if not given default is 1, 
% ptype=plot type (as in plotsol), if not given default is 1.
%
% See aso specGu, plotsol
function muv=plotEvec(dir,varargin)
if ~ischar(varargin{1})
    p=dir; 
else 
    bfname=varargin{1}; varargin=varargin(2:end);
    p=loadp(dir,bfname);
end
evnr=varargin{1};
if(length(varargin)>1) cnr=varargin{2}; else cnr=1; end
varargin=varargin(2:end);
if(length(varargin)>1) ptype=varargin{2}; else ptype=1; end
[muv,V]=specGu(p,4);
n0=(cnr-1)*p.np+1; n1=cnr*p.np;
evr=real(V(1:p.nu,evnr)); evs=num2str(muv(evnr));
p.u=evr; plotsol(p,p.plot.ifig,cnr,ptype);
title(['Re(eigfct) of eigenvalue=' evs]);
end
